/* 
 * File:   handler.h
 * Author: Arthur Brandao
 *
 * Created on 23 novembre 2018
 */

#ifndef HANDLER_H
#define HANDLER_H

/* --- Include --- */
#include "constante.h"
#include "json.h"

/* --- Fonctions --- */
/**
 * Initialise les handlers
 */
void ini_handler();

/**
 * Handler de gestion des deconnexion des clients
 * @param int L'id du client
 * @param JsonParser* Le json envoyer par le client
 * @return int Etat
 */
int handler_client_end(int, JsonParser*);

/**
 * Liste des games actives
 * @param int L'id du client
 * @param JsonParser* Le json envoyer par le client
 * @return int Etat
 */
int handler_game_list(int, JsonParser*);

int handler_game_create(int, JsonParser*);

#endif /* HANDLER_H */

